//+------------------------------------------------------------------+
//|                                                    FTLM-STLM.mq4 |
//|                       Copyright  2005, Finware Technologies Ltd |
//|                                            http://www.finware.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Finware Technologies Ltd"
#property link      "http://www.finware.ru"

#property indicator_chart_window 
#property indicator_buffers 1 
#property indicator_color1  Red
#property indicator_width1  2

//
//
//
//
//

extern string TimeFrame = "Current time frame";

//
//
//
//
//
 
double rftl[];   

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
// 

int init()
{
   SetIndexBuffer(0,rftl);
   
         //
         //
         //
         //
         //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";        if (returnBars)     return(0);
         calculateValue    = TimeFrame=="calculateValue";    if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);

         //
         //
         //
         //
         //
            
   
   IndicatorShortName(timeFrameToString(timeFrame)+" Rftl");
return(0);
}
   
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int  counted_bars=IndicatorCounted();
   int  limit;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { rftl[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     for (int i=limit; i >= 0; i--)
     {
        rftl[i] = 
-0.02232324*Close[i] 
+0.02268676*Close[i+1] 
+0.08389067*Close[i+2] 
+0.14630380*Close[i+3] 
+0.19282649*Close[i+4] 
+0.21002638*Close[i+5] 
+0.19282649*Close[i+6] 
+0.14630380*Close[i+7] 
+0.08389067*Close[i+8] 
+0.02268676*Close[i+9] 
-0.02232324*Close[i+10] 
-0.04296564*Close[i+11] 
-0.03980614*Close[i+12] 
-0.02082171*Close[i+13] 
+0.00243636*Close[i+14] 
+0.01950580*Close[i+15] 
+0.02460929*Close[i+16] 
+0.01799295*Close[i+17] 
+0.00470540*Close[i+18] 
-0.00831985*Close[i+19] 
-0.01544722*Close[i+20] 
-0.01456262*Close[i+21] 
-0.00733980*Close[i+22] 
+0.00201852*Close[i+23] 
+0.00902504*Close[i+24] 
+0.01093067*Close[i+25] 
+0.00766099*Close[i+26] 
+0.00145478*Close[i+27] 
-0.00447175*Close[i+28] 
-0.00750446*Close[i+29] 
-0.00671646*Close[i+30] 
-0.00304016*Close[i+31] 
+0.00143433*Close[i+32] 
+0.00457475*Close[i+33] 
+0.00517589*Close[i+34] 
+0.00336708*Close[i+35] 
+0.00034406*Close[i+36] 
-0.00233637*Close[i+37] 
-0.00352280*Close[i+38] 
-0.00293522*Close[i+39] 
-0.00114249*Close[i+40] 
+0.00083536*Close[i+41] 
+0.00215524*Close[i+42] 
+0.00604133*Close[i+43] 
-0.00013046*Close[i+44];


   
   }
   return(0);
  }

  //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         rftl[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",0,y);   
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}